r"""
Copyright &copy; 2023 NetApp Inc.
All rights reserved.

This file has been automatically generated based on the ONTAP REST API documentation.

"""

from marshmallow import EXCLUDE, fields  # type: ignore
from netapp_ontap.resource import Resource, ResourceSchema, ResourceSchemaMeta, ImpreciseDateTime, Size


__all__ = ["LicensePackageLicenses", "LicensePackageLicensesSchema"]
__pdoc__ = {
    "LicensePackageLicensesSchema.resource": False,
    "LicensePackageLicensesSchema.opts": False,
    "LicensePackageLicenses": False,
}


class LicensePackageLicensesSchema(ResourceSchema, metaclass=ResourceSchemaMeta):
    """The fields of the LicensePackageLicenses object"""

    active = fields.Boolean(data_key="active")
    r""" A flag indicating whether the license is currently being enforced. """

    capacity = fields.Nested("netapp_ontap.models.license_capacity.LicenseCapacitySchema", unknown=EXCLUDE, data_key="capacity")
    r""" The capacity field of the license_package_licenses. """

    compliance = fields.Nested("netapp_ontap.models.license_compliance.LicenseComplianceSchema", unknown=EXCLUDE, data_key="compliance")
    r""" The compliance field of the license_package_licenses. """

    evaluation = fields.Boolean(data_key="evaluation")
    r""" A flag indicating whether the license is in evaluation mode. """

    expiry_time = ImpreciseDateTime(data_key="expiry_time")
    r""" Date and time when the license expires.

Example: 2019-03-02T19:00:00Z """

    host_id = fields.Str(data_key="host_id")
    r""" A string that associates the license with a node or cluster.

Example: 456-44-1234 """

    installed_license = fields.Str(data_key="installed_license")
    r""" Name of license that enabled the feature.

Example: Core Bundle """

    owner = fields.Str(data_key="owner")
    r""" Cluster, node or license manager that owns the license.

Example: cluster1 """

    serial_number = fields.Str(data_key="serial_number")
    r""" Serial number of the license.

Example: 123456789 """

    shutdown_imminent = fields.Boolean(data_key="shutdown_imminent")
    r""" A flag indicating whether the Cloud ONTAP system is going to shutdown as the Cloud platform license has already expired. """

    start_time = ImpreciseDateTime(data_key="start_time")
    r""" Date and time when the license starts.

Example: 2019-02-02T19:00:00Z """

    @property
    def resource(self):
        return LicensePackageLicenses

    gettable_fields = [
        "active",
        "capacity",
        "compliance",
        "evaluation",
        "expiry_time",
        "host_id",
        "installed_license",
        "owner",
        "serial_number",
        "shutdown_imminent",
        "start_time",
    ]
    """active,capacity,compliance,evaluation,expiry_time,host_id,installed_license,owner,serial_number,shutdown_imminent,start_time,"""

    patchable_fields = [
        "capacity",
        "compliance",
    ]
    """capacity,compliance,"""

    postable_fields = [
        "capacity",
        "compliance",
    ]
    """capacity,compliance,"""


class LicensePackageLicenses(Resource):

    _schema = LicensePackageLicensesSchema
